/* inistrings.h
 *
 *  Scott Lawrence
 *  yorgle@gmail.com
 *
 *  This was brought forth from my "Turaco" project, circa 2003
 *  Before that, it was used in my PLFI project, circa 1996
 */

/*
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 */


/*
 * inistrings_makeFirstNull
 *
 *  nulls out the first occurrance of 'c'
 */
char * inistrings_makeFirstNull( char * buf, int max, char c );

/* 
 * inistrings_trimWhitespace
 *
 *  converts something like "   hello there   " into "hello there"
 */
char * inistrings_trimWhitespace( char * buf, int max );

/*
 * inistrings_strchrIndex
 *
 *  finds the first occurrance of 'C' after index 'start'
 */
int inistrings_strchrIndex( char * buf, int max, char c, int start );

/*
 * inistrings_whiteSpaceArray
 *
 *  gets the [n]th element from the string passed in.
 *  string returned should not be free'd.  if the index was invalid,
 *  it returns a NULL.
 */
char * inistrings_whiteSpaceArray( char * buf, int index );
