/* Llist
 *
 *  llauncher llist mmanager
 *      
 *      (c)2006 Scott Lawrence
 *	   yorgle@gmail.com
 */

/*
 * Copyright (C) 2006/2007 Scott Lawrence
 *
 * WARNING: May contain trace amounts of monkeys.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 */
#include "pz.h"

#define LLAUNCHER_FLAGS_NONE	(0)
#define LLAUNCHER_FLAGS_ICON	(0x0001)	/* display the icon */
#define LLAUNCHER_FLAGS_TEXT	(0x0002)	/* display the text */


typedef struct Llauncher_Item {
	char * menuGroup;	/* group name */
	char * title;		/* display text for the item / menu header */
	char * info;		/* additional textual information */
	ttk_color bg;		/* for text and image */
	ttk_color fg;		/* for text and image */
	ttk_surface image; 	/* menu: background image */
	ttk_surface icon;
	int flags;		/* see above */
	int arrowW;		/* size of navigation arrows */
	int arrowH;		/* size of navigation arrows */

	/* for launchables */
	char * workingDirectory;
	char * command;			/* REQUIRED for launchables */

	struct Llauncher_Item *items;	/* points to a list of menu items */
					/* REQUIRED for subitems */

	struct Llauncher_Item *next;	/* points to the next menu item */
	struct Llauncher_Item *previous;/* points to the previous menu item */

	struct Llauncher_Item *parent;	/* points to the item's parent */
} LLAUNCHER_ITEM;

/* We determine if the item is a launchable or a submenu like so:
    if( li->command ) {
		IT IS LAUNCHABLE
    } else if( li->items ) {
		IT IS A SUBMENU
    } else {
		IT IS A DUMMY ITEM, DISPLAYED LIKE A LAUNCHABLE
    }
*/



LLAUNCHER_ITEM * llauncher_new();
void llauncher_delete( LLAUNCHER_ITEM * li );
LLAUNCHER_ITEM * llauncher_findMenu( LLAUNCHER_ITEM * tree, char * name );
LLAUNCHER_ITEM * llauncher_addMenu( 
                        LLAUNCHER_ITEM * tree, INIStruct * parsedFile,
                        char * menuGroup, int level );
LLAUNCHER_ITEM * llauncher_buildMenus( INIStruct * parsedFile );

/*

    -> is analogous to the "items" pointer above
    |  is analogous to the "next" pointer above

	[groupName]->items
	 |
	next

    [] brakcets specify a LAUNCHABLE
    () parenthesis specify a SUBMENU

	(Root)->(Games Menu)->(Doom Based Games)->[DoomGame]
		 |	       |                   |
		 |             |                  [HereticGame]
		 |             |
		 |            (Mame Based Games)->[PacMan]
		 |             |                   |
		 |             |                  [Ms PacMan]
		 |             |                   |
		 |             |                  [Pengo]
		 |             |
		 |            (iBoy Based Games)->[Tetris]
		 |
		(Utils)->[MOTD]
		          |
			 [DMESG]
*/
