/* Search.c
 *
 *      (c)2007 Scott Lawrence
 *	   yorgle@gmail.com
 */

/*
 * Copyright (C) 2007 Scott Lawrence
 *
 * WARNING: May contain trace amounts of monkeys.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 */

#include <string.h>
#include <stdio.h>


/* places to look for the configuration (INI) file */
char *llauncher_searchPath[10] =
{
	/* AppleOS Notes directory */
	"/Notes/%s",
	"/mnt/Notes/%s",
	"/hp/Notes/%s",

	/* Root of the DOS partition */
	"/mnt/%s",
	"/hp/%s",

	/* In the Linux tree */
	"/etc/%s",

	/* Root of the HFS or EXT parition */
	"/%s",

	/* current directory - or exact path */
	"%s",

	/* handy for debugging */
	"modules/llauncher/%s",
	NULL
};


/*
**  _resolve_filepath - go through the filepath and try files until it finds one
*/
char * llauncher_resolve_filepath( char ** paths, char * filename )
{
	FILE * tst;
	int idx = 0;
	char temp[ 512 ]; /* not great, but good enough for now */

	/* just in case... */
	if( !paths || !filename )
	{
		return NULL;
	}

	while( paths[idx] != NULL ) {
		snprintf( temp, 512, paths[idx], filename );
		tst = fopen( temp, "r" );
		if( tst ) {
			fclose( tst );
			return( strdup( temp ));
		}
		idx++;
	}

	return NULL;
}
